'FFSubmenu=Exif
'FFName=CopyExif
'//FFSubmenu=Tools
'//FFName=CopyExif
'//FFPath=copyexif.vbs

' search_exif.vbs
'*********************************************************
' CopyExif v1.5
' (C) Zaph 09/2003
' Email: zaphl@gmx.de
'
' ablauffhig ab Fixfoto V2.71 B:46
' Fixfoto: http://www.j-k-s.com
'
' Zeigt vom ersten in der Computeransicht markierten Bild
' die Exifdaten an.
' Die im Dialogfenster markierten Exifdaten knnen
' per Knopfdruck in die Windows-Zwischenablage kopiert
' werden.
'
' nderungen:
' V1.1:	erweiterte Exif-Information im flash-Tag,
'		Script luft unabhngig von der Lndereinstellung,
'		Formatierung Text/HTML/YaBB-Forum -Format
' V1.2: zustzliches Format phpForum
'		(Code von Reiner)
' V1.3: UserComment hinzugefgt, Bug in Versionsabfrage
'		gefixt
' V1.4: Anpassung an nderung Combobox, Erweiterungen Exifklartexte
' V1.5: Bugfixing (Belichtungszeit, Blitz)
' V1.6: Anpassung an nderungen bei FF durch Stefan_G. mit Hilfe von hhoefling
'*********************************************************

option explicit

dim FFPath
dim exifTagList
Const cmdOK = "Markierte Exifdaten in Zwischenablage kopieren"
Const cmdCancel = "Abbrechen"
Const WS_TABSTOP = &H10000
Const WS_VSCROLL = &H200000
Const ForReading = 1, ForWriting = 2

dim wsShell, fso
set wsShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")

Main

set fso = nothing
set wsShell = nothing
' Ende

sub Main
	dim ok, imagenum

	' Version checken
	if not CheckBuild("2.71.46") then
		msgbox "Dieses Script luft erst ab FF Version 2.71 Build 46 - Abbruch!", vbCritical, "CopyExif"
		exit sub
	end if

	imagenum = FF_GetImageCount
	if imagenum = 0 then
		msgbox "Kein Bild ausgewhlt - Abbruch!", vbCritical, "CopyExif"
		exit sub
	end if

	On Error Resume Next
'	FFPath = wsShell.RegRead("HKEY_USERS\.DEFAULT\Software\FixFoto\InstPath")
	if Err.number <> 0 then
		msgbox "Abbruch - Fixfoto-Installationsverzeichnis nicht in Registry gefunden!", VBExclamation
		exit sub
	end if
	on error goto 0

	' Exif-Tagliste aufbauen
	buildExifList exifTagList

	FF_LoadExif FF_GetImageName(0)

	ShowExif

end sub

' Ende Hauptprogramm

'*********************************************************
' ShowExif: Dialogmaske
'*********************************************************
sub ShowExif
	dim iniFileName, iniFile
	Dim fx,fy,dfx,dfy,fh,dw,dh
	dim exifListe
	dim fldExifValue, i, j
	dim line
	dim iniTags
	dim exFormat
	dim ta, tt, te
	dim ausgleich

	const dlgShowExif = "CopyExif Zaph 2003"
	const cmbFormat = "cmbFormat"


	iniFileName = FFPath & "\copyexif.ini"
	addList2 iniTags, "", ""
	if fso.FileExists(iniFileName) then
		on error goto 0
		Set iniFile = fso.OpenTextFile(iniFileName, ForReading, True)
		Do While iniFile.AtEndOfStream <> True
			line = iniFile.ReadLine
			if trim(line) <> "" then
				tt = Split(line, "#", -1)
				addList2 iniTags, tt(0), tt(1)
			end if
		Loop
		iniFile.Close
	end if

	' Fensterabmessungen
	dw = 190
	dh = 278
	' linke obere Ecke im Dialogfenster
	fx = 5
	fy = 5
	' Abstand zwischen zwei Dialogzeilen
	dfy = 8
	' Abstand zwischen zwei Spalten
	dfx = 80
	' Hhe einer Dialogzeile
	fh = 10

	' Dialog erzeugen
	FF_AddDialog dlgShowExif, dw, dh

	FF_AddControl dlgShowExif, "Export-Format:", "STATIC", fx, fy, 35, fh
	FF_AddControl dlgShowExif, cmbFormat, "COMBO", fx+40, fy, 50, fh
	FF_SetControl dlgShowExif, cmbFormat, "Text"
	FF_SetControl dlgShowExif, cmbFormat, "YaBB Forum"
	FF_SetControl dlgShowExif, cmbFormat, "YaBB Forum"
	FF_SetControl dlgShowExif, cmbFormat, "phpBB Forum"
	FF_SetControl dlgShowExif, cmbFormat, "HTML"
	FF_SetControlStyle dlgShowExif, cmbFormat, WS_TABSTOP + WS_VSCROLL

	fy = fy + dfy + 5

	for i = 0 to ubound(exifTagList,2)
		FF_AddControl dlgShowExif, "bol" & exifTagList(0,i), "BOOL", fx, fy, 10, fh
		FF_AddControl dlgShowExif, exifTagList(1,i), "STATIC", fx+12, fy, dfx, fh
		for j = 0 to ubound(iniTags,2)
			if iniTags(0,j) = exifTagList(0,i) then _
				FF_SetControl dlgShowExif, "bol" & exifTagList(0,i), iniTags(1,j)
		next
		fldExifValue = "fld" & exifTagList(0,i)
		FF_AddControl dlgShowExif, fldExifValue, "EDIT", fx+100, fy, dfx, fh
		FF_SetControl dlgShowExif, fldExifValue, FF_GetExifTag(exifTagList(0,i))
		FF_SetControl dlgShowExif, fldExifValue, getFormattedExitValue(exifTagList(0,i))
		FF_EnableControl dlgShowExif, fldExifValue, false
		fy = fy + dfy
	next

	' OK, Cancel
	FF_AddControl dlgShowExif, cmdOK, "BUTTON", dw-185, dh-13, 135, fh
	FF_AddControl dlgShowExif, cmdCancel, "BUTTON", dw-45, dh-13, 40, fh

	'FF_ActivateControl dlgShowExif, "txtSearch"

	Do
	' Dialog ffnen
	select case FF_ShowDialog(dlgShowExif)
	case cmdCancel
		FF_CloseDialog dlgShowExif
		Exit Do
	case cmdOK
		On Error Resume Next
		Set iniFile = fso.OpenTextFile(iniFileName, ForWriting, True)
		if Err.number <> 0 then
			msgbox "Abbruch - Kann " & iniFileName & " nicht zum Schreiben ffnen!", VBExclamation
			exit sub
		end if
		on error goto 0
		exFormat = FF_GetControl(dlgShowExif, cmbFormat)
		select case exFormat
		case "HTML"
			exifListe = "<table>" & vbNewline
			ta = "<tr><td><b>"
			tt = "</b></td><td>"
			te = "</td></tr>" & vbNewline
		case "YaBB Forum"
			exifListe = "[table]"
			ta = "[tr] [td] [b]"
			tt = "[/b] [/td] [td]"
			te = "[/td] [/tr]"
		case "phpBB Forum"
			exifListe = "[code]" & vbNewline
			ta = ""
			tt = ": "
			te = "" & vbNewline
		case else
			exifListe = ""
			ta = ""
			tt = ": "
			te = vbNewline
		end select
		for i = 0 to ubound(exifTagList,2)
			if FF_GetControl(dlgShowExif, "bol" & exifTagList(0,i)) = "1" then
				if exFormat = "phpBB Forum" then
					ausgleich = 40 - LEN (exifTagList(1,i))
					exifListe = exifListe & ta & exifTagList(1,i) & string(ausgleich, " ") & tt & getFormattedExitValue(exifTagList(0,i)) & te
				else
					exifListe = exifListe & ta & exifTagList(1,i) & tt & getFormattedExitValue(exifTagList(0,i)) & te
				end if
				iniFile.writeLine exifTagList(0,i) & "#" & "1"
			else
				iniFile.writeLine exifTagList(0,i) & "#" & "0"
			end if
		next
		iniFile.Close
		select case exFormat
		case "HTML"
			exifListe = exifListe & "</table>"
		case "YaBB Forum"
			exifListe = exifListe & "[/table]"
		case "phpBB Forum"
			exifListe = exifListe & "[/code]"
		end select
'		FF_CloseDialog dlgShowExif
		FF_TextToClipboard exifliste
'		msgbox exifListe
		msgbox "Markierte Exif-Daten in die Zwischenablage kopiert.", vbInformation, "CopyExif"
		FF_CloseDialog dlgShowExif
		Exit Do
	end select
	loop
end sub

'*********************************************************
' gibt den formatierten Exifwert von den aktuellen
' Exifdaten zurck
'*********************************************************
function getFormattedExitValue(tag)
	getFormattedExitValue = formatExif(tag,FF_GetExifTag(tag))
end function

'*********************************************************
' formatiert den bergebenen Exifwert in deutsch
'*********************************************************
function formatExif(tag, wert)
	dim dt, jmt, tim
	on error resume next
	select case tag
	case "DateTime", "DateTimeOriginal", "DateTimeDigitized"
		dt = Split(wert, " ", -1)
		jmt = Split(dt(0), ":", -1)
		formatExif = jmt(2) & "." & jmt(1) & "." & jmt(0) & " " & dt(1)
		if Err.Number <> 0 then formatExif = wert
	case "ExposureTime"
		tim = cdbl(clang(wert))
		if tim < 1 then
			formatExif = "1/" & cstr(round(1/tim))
			if Err.Number <> 0 then formatExif = wert
		else
			formatExif = tim
		end if
		if formatExif <> "" then formatExif = formatExif & " sec"
	case "ShutterSpeedValue"
		tim = 1/2^cdbl(clang(wert))
		if tim < 1 then
			formatExif = "1/" & cstr(round(tim))
			if Err.Number <> 0 then formatExif = wert
		else
			formatExif = tim
		end if
		if formatExif <> "" then formatExif = formatExif & " sec"
	case "ExposureProgram"
		select case wert
		case "1"
			formatExif = "Manuell"
		case "2"
			formatExif = "Programm"
		case "3"
			formatExif = "Blende"
		case "4"
			formatExif = "Zeit"
		case "5"
			formatExif = "Kreativ"
		case "6"
			formatExif = "Action"
		case "7"
			formatExif = "Portrait"
		case "8"
			formatExif = "Landschaft"
		case else
			formatExif = wert
		end select
	case "BrightnessValue", "ExposureBiasValue"
		formatExif = cdbl(clang(wert))
		if Err.Number <> 0 then formatExif = wert
		if formatExif <> "" then formatExif = formatExif & " APEX"
	case "Flash"
		select case cint(wert)
		case &H00
			formatExif = "Blitz nicht gefeuert"
		case &H01
			formatExif = " Blitz gefeuert"
		case &H05
			formatExif = " reflektiertes Impulslicht nicht erkannt"
		case &H07
			formatExif = " reflektiertes Impulslicht erkannt"
		case &H09
			formatExif = " Blitz gefeuert, Blitzmodus:an"
		case &H0D
			formatExif = " Blitz gefeuert, Blitzmodus:an, reflektiertes Licht nicht erkannt"
		case &H0F
			formatExif = " Blitz gefeuert, Blitzmodus:an, reflektiertes Licht erkannt"
		case &H10
			formatExif = " Blitz nicht gefeuert, Blitzmodus:an"
		case &H18
			formatExif = " Blitz nicht gefeuert, Blitzmodus:auto"
		case &H19
			formatExif = " Blitz gefeuert, Blitzmodus:auto"
		case &H1D
			formatExif = " Blitz gefeuert, Blitzmodus:auto, reflektiertes Licht nicht erkannt"
		case &H1F
			formatExif = " Blitz gefeuert, Blitzmodus:auto, reflektiertes Licht erkannt"
		case &H20
			formatExif = " keine Blitzfunktion"
		case &H41
			formatExif = " Blitz gefeuert, Rote-Augen Funktion"
		case &H45
			formatExif = " Blitz gefeuert, Rote-Augen Funktion, reflektiertes Licht nicht erkannt"
		case &H47
			formatExif = " Blitz gefeuert, Rote-Augen Funktion, reflektiertes Licht erkannt"
		case &H49
			formatExif = " Blitz gefeuert, Blitzmodus:an, Rote-Augen Funktion"
		case &H4D
			formatExif = " Blitz gefeuert, Blitzmodus:an, Rote-Augen Funktion, reflektiertes Licht nicht erkannt"
		case &H4F
			formatExif = " Blitz gefeuert, Blitzmodus:an, Rote-Augen Funktion, reflektiertes Licht erkannt"
		case &H59
			formatExif = " Blitz gefeuert, Blitzmodus:auto, Rote-Augen Funktion"
		case &H5D
			formatExif = " Blitz gefeuert, Blitzmodus:auto, reflektiertes Licht nicht erkannt, Rote-Augen Funktion"
		case &H5F
			formatExif = " Blitz gefeuert, Blitzmodus:auto, reflektiertes Licht erkannt, Rote-Augen Funktion"
		case &HFF
			formatExif = "andere"
		case else
			formatExif = wert
		end select
	case "LightSource"
		select case wert
		case "0"
			formatExif = "unbekannt"
		case "1"
			formatExif = "Tageslicht"
		case "2"
			formatExif = "Leuchtstoffrhre"
		case "3"
			formatExif = "Glhlampe"
		case "4"
			formatExif = "Blitz"
		case "9"
			formatExif = "Sonnig"
		case "10"
			formatExif = "Wolkig"
		case "11"
			formatExif = "Schatten"
		case "12"
			formatExif = "Leuchtstofflampe, Tageslicht (D 5700-7100K)"
		case "13"
			formatExif = "Leuchtstofflampe, neutrales Tageslicht (N 4600-5400K)"
		case "14"
			formatExif = "Leuchtstofflampe, khles Wei (W 3900-4500K)"
		case "15"
			formatExif = "Leuchtstofflampe, Wei (WW 3200-3700K)"
		case "17"
			formatExif = "Standardlicht A"
		case "18"
			formatExif = "Standardlicht B"
		case "19"
			formatExif = "Standardlicht C"
		case "20"
			formatExif = "D55"
		case "21"
			formatExif = "D65"
		case "22"
			formatExif = "D75"
		case "24"
			formatExif = "ISO Studiolampe"
		case "255"
			formatExif = "andere Lichtquelle"
		case else
			formatExif = wert
		end select
	case "MeteringMode"
		select case wert
		case "0"
			formatExif = "unbekannt"
		case "1"
			formatExif = "Durchschnitt"
		case "2"
			formatExif = "Mittenbetont"
		case "3"
			formatExif = "Spot"
		case "4"
			formatExif = "Multi-Spot"
		case "5"
			formatExif = "Multi-Segment"
		case "6"
			formatExif = "Partiell"
		case "255"
			formatExif = "andere"
		case else
			formatExif = wert
		end select
	case "Orientation"
		select case wert
		case "1"
			formatExif = "oben/linke Seite"
		case "2"
			formatExif = "oben/rechte Seite"
		case "3"
			formatExif = "unten/rechte Seite"
		case "4"
			formatExif = "unten/linke Seite"
		case "5"
			formatExif = "linke Seite/oben"
		case "6"
			formatExif = "rechte Seite/oben"
		case "7"
			formatExif = "rechte Seite/unten"
		case "8"
			formatExif = "linke Seite/unten"
		case else
			formatExif = wert
		end select
	case "ResolutionUnit"
		select case wert
		case "1"
			formatExif = "keine Einheit"
		case "2"
			formatExif = "inch"
		case "3"
			formatExif = "cm"
		case else
			formatExif = wert
		end select
	case "ApertureValue"
		formatExif = FormatNumber(sqr(2)^cdbl(clang(wert)),1)
		if Err.Number <> 0 then formatExif = wert
	case "FNumber", "MaxApertureValue", "ExposureBiasValue"
		formatExif = FormatNumber(cdbl(clang(wert)),1)
		if Err.Number <> 0 then formatExif = wert
		if formatExif <> "" then formatExif = formatExif & " F"
	case "FocalLength"
		formatExif = FormatNumber(cdbl(clang(wert)),1)
		if Err.Number <> 0 then formatExif = wert
		if formatExif <> "" then formatExif = formatExif & " mm"
	case "SubjectDistance"
		formatExif = FormatNumber(cdbl(clang(wert)),2)
		if Err.Number <> 0 then formatExif = wert
		if formatExif <> "" then formatExif = formatExif & " m"
	case "XResolution", "YResolution"
		formatExif = cint(clang(wert))
	case else
		formatExif = wert
	end select
	on error goto 0
end function

'*********************************************************
' clang konvertiert eine Zahl in einem String in ein
' Format, das mit den Konvertierungsfunktionen von
' VBScript in eine Zahl umgewandelt werden kann, abhngig
' von den Lndereinstellungen des Dezimaltrennzeichens
'*********************************************************
function clang(wert)
	if cint("1.0") = 1 then 'englisch
		clang = replace(wert,",",".")
	else 'deutsch
		clang = replace(wert,".",",")
	end if
end function

'*********************************************************
' buildExifList baut die Exif-Tagliste auf
' exifTagList: dynamisches Array mit den Exif-Tagnamen
'*********************************************************
sub buildExifList (exifTagList)
	addList2 exifTagList,"DateTime","nderungsdatum"
	addList2 exifTagList,"DateTimeOriginal","Aufnahmedatum"
	addList2 exifTagList,"DateTimeDigitized","Digitalisierungsdatum"

	addList2 exifTagList,"ImageDescription","Beschreibung"
	addList2 exifTagList,"UserComment","Kommentar"
	addList2 exifTagList,"Copyright1","Copyright 1"
	addList2 exifTagList,"Copyright2","Copyright 2"
	addList2 exifTagList,"ApertureValue","Blende (ApertureValue)"
	addList2 exifTagList,"FNumber","Blende (FNumber)"
	addList2 exifTagList,"Artist","Fotograf"

	addList2 exifTagList,"BrightnessValue","Helligkeit"
	addList2 exifTagList,"ExposureBiasValue","Belichtungskorrektur"
	addList2 exifTagList,"ExposureIndex","Belichtungsindex"
	addList2 exifTagList,"ExposureProgram","Belichtungsprogramm"
	addList2 exifTagList,"ExposureTime","Belichtungszeit (ExposureTime)"
	addList2 exifTagList,"ShutterSpeedValue","Belichtungszeit (ShutterSpeedValue)"
	addList2 exifTagList,"Flash","Blitz"
	addList2 exifTagList,"FocalLength","Brennweite"
	addList2 exifTagList,"ISOSpeedRatings","ISO Wert"
	addList2 exifTagList,"LightSource","Lichtquelle (Weissabgleich)"
	addList2 exifTagList,"MaxApertureValue","Maximale Blende"
	addList2 exifTagList,"MeteringMode","Messmethode"
	addList2 exifTagList,"SubjectDistance","Objektentfernung"
	addList2 exifTagList,"Orientation","Orientierung"

	addList2 exifTagList,"Make","Hersteller"
	addList2 exifTagList,"Model","Modell"
	addList2 exifTagList,"Software","Software"

	addList2 exifTagList,"ResolutionUnit","Auflsungseinheit"
	addList2 exifTagList,"XResolution","X-Auflsung"
	addList2 exifTagList,"YResolution","Y-Auflsung"
end sub

'*********************************************************
' addList2 fgt einem zweidimensionale dynamisches Array
' einen Listeneintrag hinzu
' list:  dynamische Array der Dimension (1,x)
' term1: Listeneintrag fr die erste Dimension
' term2: Listeneintrag fr die zweite Dimension
'*********************************************************
sub addList2(byref list, term1, term2)
	if isempty(list) then
		redim list(1,0)
	else
		redim preserve list(1,ubound(list,2)+1)
	end if
	list(0,ubound(list,2))=term1
	list(1,ubound(list,2))=term2
end sub

'*********************************************************
' checkt die aktuelle Version gegen eine minimal geforderte
' Version
' In:
' refBuild: Major.Minor.Build
' z.B.: "2.71.31"
' Out:
' CheckBuild: true oder false
'*********************************************************
function CheckBuild(refBuild)
	dim refver, aktver(2), i
	refver = split(refBuild,".",-1)
	for i=0 to 2
		refver(i) = cint(refver(i))
	next
	On Error Resume Next
	aktver(0) = FF_GetMajor()
	if err.number then
		CheckBuild = false
		exit function
	end if
	On Error goto 0
	aktver(1) = FF_GetMinor()
	aktver(2) = FF_GetBuild()
	if aktver(0) > refver(0) then
		CheckBuild = true
		exit function
	elseif aktver(0) = refver(0) then
		if aktver(1) > refver(1) then
			CheckBuild = true
			exit function
		elseif aktver(1) = refver(1) then
			if aktver(2) >= refver(2) then
				CheckBuild = true
				exit function
			end if
		else
			CheckBuild = false
			exit function
		end if
	else
		CheckBuild = false
		exit function
	end if
end function